import java.util.ArrayList;
import java.util.Collections;
import java.util.List;
/** Examples of generic methods that require manual specification
 *  @author Josh Hug
 */

public class GenericMethodsDemo {



    public static <T> ArrayList<T> freshArrayList() {
        return new ArrayList<T>();
    }

    public static <T>int getSize(ArrayList<String> al) {
        return al.size();
    }

    public static <T> T getZerothItem(List<T> L) {
        return L.get(0);
    }

    public static void main(String[] args) {
        ArrayList<String> als = new ArrayList<String>();
        String s = GenericMethodsDemo.<String>getZerothItem(als);
        s = getZerothItem(als);




        ArrayList<String> al = freshArrayList();
        al.add("hello");
        System.out.println(al);

        ArrayList<String> al2 = GenericMethodsDemo.<String>freshArrayList();

        /* The Java inference engine fails for the following call. Requires
           a type witness. This is not important for 61B, but I am
           including this just to give a tiny peek into a big messy
           world that you should NOT try to learn unless you are
           very curious. We will not ask questions about type inference
           corner cases or type witnesses on an exam. 

        System.out.println(getSize(freshArrayList())); */

        System.out.println(getSize(GenericMethodsDemo.<String>freshArrayList()));
    }

    /** Return type cannot be wildcard!

    public static ? getZerothItem(List<?> L) {
        return L.get(0);
    }

    */    
} 